;The G.E.C.K. PowerUp for New Vegas - Part of the library
;Patch to display message boxes in English, not in system language
;File version 0.1
;Written by Fedor Uvarov, 2010

PATCH_MESSAGEBOX_IMPORT_OFFSET = 00D2253Ch
PATCH_MESSAGEBOX_IMPORT_LENGTH = 4

macro MESSAGEBOX_PATCHES {
;We need not make memory executable here
mov [OldProtectionOffset], PATCH_MESSAGEBOX_IMPORT_OFFSET
mov [OldProtectionLength], PATCH_MESSAGEBOX_IMPORT_LENGTH
invoke VirtualProtect, PATCH_MESSAGEBOX_IMPORT_OFFSET, PATCH_MESSAGEBOX_IMPORT_LENGTH, PAGE_READWRITE, OldProtection
.if ~ eax
	call PatchAbort
.endif
mov [PATCH_MESSAGEBOX_IMPORT_OFFSET], DWORD Callback_MessageBox
call RestoreMemProtection
}

macro MESSAGEBOX_CALLBACKS {
Callback_MessageBox:
	;We're supposed to be MessageBoxA
	;Moving arguments
	sub esp, 4
	mov edx, esp
	mov ecx, 5	;4 args + return address
	.moveargs: mov eax, [esp+4]
	mov [esp], eax
	add esp, 4
	loop .moveargs
	
	;Adding language
	mov [esp], DWORD LANG
	mov esp, edx
	push [MessageBoxEx]
	retn
}