;The G.E.C.K. PowerUp for New Vegas - Part of the library
;Patch that restores warning messages in the script compiler
;File version 0.2.2
;Written by Fedor Uvarov, 2010
;Patched to support G.E.C.K 1.4 by H. LE PORS ( 1 July 2011)

PATCH_SCRIPTS_WARNINGS_OFFSET = 005C57E2h	;       005C5652h       ;       005C5212h exact same code
PATCH_SCRIPTS_WARNINGS_LENGTH = 11d

macro SCRIPTS_WARNINGS_DATA {
WarningCaptionScripts db "Warning - PowerUp - SCRIPTS", 0
}

macro SCRIPTS_WARNINGS_PATCHES {
stdcall MakeMemWriteable, PATCH_SCRIPTS_WARNINGS_OFFSET, PATCH_SCRIPTS_WARNINGS_LENGTH
;Current code: C78424 20010000 FFFFFFFF (MOV DWORD PTR SS:[ESP+120h],-1)
mov [PATCH_SCRIPTS_WARNINGS_OFFSET], DWORD 50h	;push eax
mov [PATCH_SCRIPTS_WARNINGS_OFFSET+1], DWORD 0B8h	;mov eax, ...
mov [PATCH_SCRIPTS_WARNINGS_OFFSET+2], DWORD Callback_ShowScriptWarning
mov [PATCH_SCRIPTS_WARNINGS_OFFSET+6], WORD 0D0FFh	;call eax
mov [PATCH_SCRIPTS_WARNINGS_OFFSET+8], WORD 9090h
mov [PATCH_SCRIPTS_WARNINGS_OFFSET+10], BYTE 90h
call RestoreMemProtection
}

macro SCRIPTS_WARNINGS_CALLBACKS {
Callback_ShowScriptWarning:
	mov eax, [esp+4]
	
	ShowWarning WarningCaptionScripts, eax, MB_YESNOCANCEL + MB_ICONWARNING
	
	mov DWORD [esp+128h], -1	;120d + 1 own arg + return address
	retn 4
}